﻿/*
  LED

  ボード上のLED2の明滅。
  e097b_def.h をインクルードしておけば端子機能の設定ライブラリによって半
  ば勝手に初期化され、同じくヘッダに定義された SetLED や ToggleLED を使っ
  明滅。

  ・LED2はシンク接続(0出力で点灯)
  ・遅延など時間にかかる部分は wl_delay.h のライブラリを使用しているが、
    FROの精度が±1%な事もあり分オーダになれば積算誤差は歴然としてくる
*/

// ペリフェラルのマクロとLPCOpenライブラリ
#include  <chip.h>
// ボードの端子割り当てと最小限の初期化
#include  "e097b_def.h"
// 遅延に関する関数
#include  <wl_delay.h>

// main
//-----------------------------
void main (void) {
  for (int i = 0; i < 10; i++) {
    // LEDを消灯
    SetLED (false);
    Delay_ms (100);   // 0.1秒待機
    // LEDを点灯
    SetLED (true);
    Delay_ms (100);
  }

  while (1) {
    // LEDの状態を反転
    ToggleLED();
    // 1秒待ち
    Delay_ms (1000);  // 1秒待機
  }
}
