#define _DYNAMICLOAD

 #include <windows.h>
 #include <fcntl.h>
 #include <stdio.h>
 #include <io.h>

#include <stdio.h>
#include <process.h>
#include <conio.h>
#include "b3mlib.h"

// }N`
#define _COMPORT   (3)        // |[gԍ
#define _BAUDRATE  (1000000)  // {[[g[bps]
#define _TARGETID  (1)        // ΏۂƂȂID

bool terminate = FALSE;

typedef struct {
  int16_t acc_x;    // Acceleration Data
  int16_t acc_y;
  int16_t acc_z;
  int16_t mag_x;    // Magnetometer Data
  int16_t mag_y;
  int16_t mag_z;
  int16_t gyro_x;   // Gyroscope Data
  int16_t gyro_y;
  int16_t gyro_z;
  int16_t heading;  // Euler Data
  int16_t roll;
  int16_t pitch;
  int16_t q_w;      // Quaternion Data
  int16_t q_x;
  int16_t q_y;
  int16_t q_z;
  int16_t lia_x;    // Linear Acceleration Data
  int16_t lia_y;
  int16_t lia_z;
  int16_t grv_x;    // Gravity Vector Data
  int16_t grv_y;
  int16_t grv_z;
  int8_t  temp;     // Temperature
} __attribute__ ((packed)) Tbno055;

bool enable_virtual_terminal_processing(FILE *stream) {
    HANDLE handle = (HANDLE)_get_osfhandle(_fileno(stream));
    DWORD mode = 0;
    if (!GetConsoleMode(handle, &mode)) {
        // s
        return false;
    }
    if (!SetConsoleMode(handle, mode | ENABLE_VIRTUAL_TERMINAL_PROCESSING)) {
        // s
        // ÂWindowsR\[̏ꍇ GetLastError() == ERROR_INVALID_PARAMETER
        return false;
    }
    return true;
}

#define cls()           printf ("\x1b[2J");
#define gotoxy(xx, yy)  printf ("\x1b[%d;%dH", yy + 1, xx + 1);

bool InputNum (int32_t *num) {
  char buf[100];
  fgets(buf, sizeof(buf), stdin);
  rewind(stdin);
  return (strlen(buf) && sscanf(buf, "%d", num) == 1);
}

bool EditComAndBaudAndTarget (char *comport, uint32_t *comn, uint32_t *baud, uint8_t *id) {
  bool result = true;

  int32_t n;

  printf ("Input comport num (default %d) = ", _COMPORT);
  if (!InputNum (&n)) { n = _COMPORT; result = false; }
  if (n >= 1 && n <= 254) *comn = n; else *comn = _COMPORT;
  sprintf(comport, "\\\\.\\COM%d", *comn);

  printf ("Input baudrate (default %dbps) = ", _BAUDRATE);
  if (!InputNum (&n)) { n = _BAUDRATE; result = false; }
  if (n >= 9600 && n <= 2000000) *baud = n; else *baud = _BAUDRATE;

  printf ("Input target id (default %d) = ", _TARGETID);
  if (!InputNum (&n)) { n = _TARGETID; result = false; }
  if (n >= 1 && n < 0xfe) *id = n; else *id = _TARGETID;

  return result;
}

void main (void) {
  char comname[20];
  uint32_t comnum, baud;
  uint8_t id;

  TDeviceID  dev;
  TErrorCode err;
  Tbno055 bno;
  int baudind;
  uint32_t baudrate;

  enable_virtual_terminal_processing(stdout);

  EditComAndBaudAndTarget (comname, &comnum, &baud, &id);
  printf("\nCOM=%s, Baudrate=%d, id=%d\n", comname, baud, id);
  baudind = 2000000 / (baud + 1);

  if (LoadDLL ()) {
    if ((dev = B3M_OpenPort (comname, baud))) {
      printf("Open success\n");
      B3M_SetTimeOutOffset (dev, 5);

      if (/*B3M_Ping (dev, TARGETID, &err)*/true) {


uint8_t b3mid = 0;
int16_t bpos = 0;
int di = 50;
#define ADDRESS_TORQUE_ON             (0x28)  // B
#define ADDRESS_DESIRED_POSITION      (0x2A)  // W



        bool mes = false;
        bool ppp = false;
        printf ("id:%d(%d)> ", id ,baudind);
        while (1) {
          if (mes) {
            if (!B3M_ReadBlockData (dev, id, 74, (uint8_t *)&bno, sizeof (Tbno055), &err)) printf (" ERR[%04X]",err);
            else {
#if 1
              gotoxy(0, 0);
              printf ("acc:%6d,%6d,%6d\n", bno.acc_x, bno.acc_y, bno.acc_z);
              printf ("mag:%6d,%6d,%6d\n", bno.mag_x, bno.mag_y, bno.mag_z);
              printf ("gyr:%6d,%6d,%6d\n", bno.gyro_x, bno.gyro_y, bno.gyro_z);
              printf ("eul:%6d,%6d,%6d\n", bno.heading, bno.roll, bno.pitch);
              printf ("qua:%6d,%6d,%6d,%6d\n", bno.q_w, bno.q_x, bno.q_y, bno.q_z);
              printf ("lia:%6d,%6d,%6d\n", bno.lia_x, bno.lia_y, bno.lia_z);
              printf ("grv:%6d,%6d,%6d\n", bno.grv_x, bno.grv_y, bno.grv_z);
              printf ("tmp;   %3d\n", bno.temp);
#endif
            }
          }
          if (ppp) {
            bpos += di;
            if (bpos > 20000) { bpos = 20000; di = -50; }
            else if (bpos < -20000) { bpos = -20000; di = 50; }
            printf("pos:%d        \r", bpos);

            if (!B3M_WriteWordData (dev, b3mid, ADDRESS_DESIRED_POSITION, bpos, NULL)) printf ("\nwrite NG\n");
          }

          if (kbhit ()) {
            uint8_t b;
            int32_t d;
            switch (_getch ()) {

            case 'p':
              ppp = !ppp;
              if (ppp) {
                if (!B3M_WriteWordData (dev, b3mid, ADDRESS_TORQUE_ON, 0, NULL)) printf ("\ntorque on NG\n");
                else printf ("\ntorque on OK\n");
              } else {
                if (!B3M_WriteWordData (dev, b3mid, ADDRESS_TORQUE_ON, 2, NULL)) printf ("\ntorque off NG\n");
                else printf ("\ntorque off OK\n");
              }
              break;

            case 's': // 
              printf("Scan DXMIO\n");
              printf("Start baud index(0..254)=");
              if (InputNum (&d)) {
                if (d<0) d=0; else if (d>254) d=254;
                for (int i = d; i <= 254 && !kbhit(); i++) {
                  B3M_SetBaudrate (dev, (2000000 / (i + 1)));
                  for (int j = 0; j <= 254 && !kbhit(); j++) {
                    printf("Ping baud:%dbps id:%d    \r",(2000000 / (i + 1)),j);
                    if (B3M_Ping (dev, j, &err)) {
                      Sleep (50);
                      if (B3M_Ping (dev, j, &err)) {
                        if (B3M_Ping (dev, j, &err)) {
                          if (B3M_ReadByteData (dev, j, 4, &b, &err)) {
                            baudind = b;
                            id = j;
                            baudrate = (2000000 / (baudind + 1));
                            printf("Detect baud:%d(%dbps) id:%d       \n", b, baudrate, j);
                            goto find;
                          }
                        }
                      }
                    }
                  }
                  Sleep (10);
                }
find:
                if (kbhit ()) _getch();
                printf("\n");
              }
              break;
            case 'b': // {[[gύX
              printf("Change Baud\n");
              if (B3M_ReadByteData (dev, id, 4, &b, &err)) {
                printf("%d(%dbps) -> ", baudind, (2000000 / (b + 1)));
                if (InputNum (&d)) {
                  b = baudind = d;
                  printf("%s\n", B3M_WriteByteData (dev, id, 4, b, &err) ? "OK":"NG");
                  baudrate = (2000000 / (baudind + 1));
                  printf("Update baud=%d\n",baudrate);
                  B3M_SetBaudrate (dev, baudrate);
                }
              } else {
                printf (" ERR[%04X]\n", err);
                printf("Change host baud %d -> ", baudind);
                if (InputNum (&d)) {
                  b = baudind = d;
                  baudrate = (2000000 / (baudind + 1));
                  printf("%d(%d)\n",baudind, baudrate);
                  B3M_SetBaudrate (dev, baudrate);
                }
              }
              break;
            case 'n': // ID,BAUDRATE,TERMINATOR NVMۑ
              printf("Write NVM ");
              if (!B3M_WriteByteData (dev, id, 5, 1, &err)) printf(" ERR[%04X]\n", err);
              else printf("OK\n");
              break;
            case 'm': // IMU j^ON/OFF
              cls ();
              mes = !mes;
              break;
            case 'i': // IDύX
              printf("Change ID\n");
              if (B3M_ReadByteData (dev, id, 3, &b, &err)) {
                printf("%d -> ", b);
                if (InputNum (&d)) {
                  b = d;
                  if (!B3M_WriteByteData (dev, id, 3, b, &err)) printf(" ERR[%04X]\n", err);
                  id = b;
                }
              } else {
                printf (" ERR[%04X]\n", err);
                printf("Change target id %d -> ", id);
                if (InputNum (&d)) {
                  printf ("%d", d);
                  id = d;
                }
              }
              break;
            case 'l': // LED ON/OFF
              printf("Toggle LED\n");
              if (B3M_ReadByteData (dev, id, 6, &b, &err)) {
                b ^= 1;
                if (!B3M_WriteByteData (dev, id, 6, b, &err)) printf (" ERR[%04X]\n", err);
                else printf("%s\n", b == 1 ? "ON":"OFF");
              } else printf (" ERR[%04X]\n", err);
              break;
            case 't': // TERMINATOR ON/OFF
              printf("Toggle Terminator\n");
              if (B3M_ReadByteData (dev, id, 7, &b, &err)) {
                b ^= 1;
                if (!B3M_WriteByteData (dev, id, 7, b, &err)) printf (" ERR[%04X]\n", err);
                else printf("%s\n", b == 1 ? "ON":"OFF");
              } else printf (" ERR[%04X]\n", err);
              break;
            case '!': // I
            case 0x1b:
              printf("Fin\n");
              return ;
              break;
            default:
              printf("\n");
              break;
            }
            printf ("id:%d(%d)> ", id ,baudind);
          }
//          Sleep (50);
        }

      } else
        printf("Cannot find ID=%d [%04X]\n", id,err);

      B3M_ClosePort(dev);
    } else {
      printf("Open error\n");
    }
    UnloadDLL ();
  }
  printf( "\nFin");
}
